<?php  


function geodir_event_manager_ajaxurl(){
	return admin_url('admin-ajax.php?action=geodir_event_manager_ajax');
}


function geodir_event_plugin_url() { 
	
	if (is_ssl()) : 
		return str_replace('http://', 'https://', WP_PLUGIN_URL) . "/" . plugin_basename( dirname(__FILE__)); 
	else :
		return WP_PLUGIN_URL . "/" . plugin_basename( dirname(__FILE__)); 
	endif;
}


function geodir_event_plugin_path() {
	return WP_PLUGIN_DIR . "/" . plugin_basename( dirname(__FILE__)); 
}


function geodir_event_add_listing_settings($arr){
	
	$event_array = array();
	foreach($arr as $key => $val){
		
		$event_array[] = $val;
		
		if($val['id'] == 'geodir_tiny_editor_on_add_listing'){
		
			$event_array[] = array(  
											'name' => __( 'Show event \'registration description\' field as editor', 'geodirevents' ),
												'desc' 		=> __( 'Select the option to show advanced editor on add listing page.', 'geodirevents' ),
												'tip' 		=> '',
												'id' 		=> 'geodir_tiny_editor_event_reg_on_add_listing',
												'css' 		=> 'min-width:300px;',
												'std' 		=> '',
												'type' 		=> 'select',
												'class'		=> 'chosen_select',
												'options' => array_unique( array( 
																			'' => __( 'Select', 'geodirevents' ),
																			'yes' => __( 'Yes', 'geodirevents' ),
																			'no' => __( 'No', 'geodirevents' ),
																		))
											);
	
		}
	}
	
	return $event_array;
}


function geodir_event_detail_page_sitebar_content($arr){
	
	$geodir_count = count($arr);
	
	$schedule_array = array();
	
	if(!empty($arr)){
		foreach($arr as $key => $val){
			
			if($geodir_count > 4){
				if( $key == 4)
					$schedule_array[] = 'geodir_event_show_shedule_date';
			}else{
				if( $key == $geodir_count)
					$schedule_array[] = 'geodir_event_show_shedule_date';
			}
			
			$schedule_array[] = $val;
		
		}
	}else{
		$schedule_array[] = 'geodir_event_show_shedule_date';
	}
	
	return $schedule_array;
}


function geodir_event_calender_search_page_title($title){
		
	global $condition_date;	
	
	if(isset($_REQUEST['event_calendar']) && !empty($_REQUEST['event_calendar']) && geodir_is_page('search'))
		$title = apply_filters('geodir_calendar_search_page_title', __(' Browsing Day', 'geodirevents').'" '.date_i18n('F  d, Y',strtotime($condition_date)).'"');
	
	return $title;
}


function geodir_event_schedule_date_fields(){
	
	global $post;
	
	$recuring_data = array();
	
	if(isset($_REQUEST['backandedit'])){
		$post = (array)$post; 
		$recuring_data['Recurring'] = isset($post['Recurring']) ? $post['Recurring'] : '';
		$recuring_data['event_day'] = isset($post['event_day']) ? $post['event_day'] : '';
		$recuring_data['event_week'] = isset($post['event_week']) ? $post['event_week'] : '';
		$recuring_data['event_month'] = isset($post['event_month']) ? $post['event_month'] : '';
		$recuring_data['event_year'] = isset($post['event_year']) ? $post['event_year'] : '';
		$recuring_data['event_start'] = isset($post['event_start']) ? $post['event_start'] : '';
		$recuring_data['event_end'] = isset($post['event_end']) ? $post['event_end'] : '';
		
		$recuring_data['event_recurring_dates']	= isset($post['event_recurring_dates']) ? $post['event_recurring_dates'] : '';
		$recuring_data['different_times'] = isset($post['different_times']) ? $post['different_times'] : '';
		$recuring_data['starttime'] = isset($post['starttime']) ?$post['starttime'] : '';
		$recuring_data['endtime']	= isset($post['endtime']) ? $post['endtime'] : '';
		$recuring_data['starttimes']	= isset($post['starttimes']) ? $post['starttimes'] : '';
		$recuring_data['endtimes']	= isset($post['endtimes']) ? $post['endtimes'] : '' ;
		
	}else{
		
		$recuring_data = unserialize($post->recurring_dates); 
	}	
	
	geodir_event_show_event_fields_html($recuring_data);
 	
}

function geodir_event_save_data( $post_id = '', $request_info ) {
	global $wpdb, $current_user; 
		
	$gd_post_info = array();
	$last_post_id = $post_id;
	$post_type = get_post_type( $post_id );
	
	if ( $post_type != 'gd_event' ) {
		return false;
	}
		
	$gd_post_info['event_reg_desc'] = isset( $request_info['event_reg_desc'] ) ? $request_info['event_reg_desc'] : '';
	$gd_post_info['event_reg_fees'] = isset( $request_info['event_reg_fees'] ) ? $request_info['event_reg_fees'] : '';
	
	$format = geodir_event_date_format();
	$default_start = date_i18n( $format, current_time( 'timestamp' ) );
	
	// Check recurring enabled
	$post_info = geodir_get_post_info( $post_id );
	$recurring_pkg = geodir_event_recurring_pkg( $post_info );
	
	// recurring event
	$is_recurring = isset( $request_info['is_recurring'] ) && empty( $request_info['is_recurring'] ) ? false : true;
	$event_date = isset( $request_info['event_date'] ) ? trim( $request_info['event_date'] ) : ( isset( $request_info['event_recurring_dates'] ) ? $request_info['event_recurring_dates'] : '' );
	$event_start = isset( $request_info['event_start'] ) ? trim( $request_info['event_start'] ) : $event_date;
	$event_end = isset( $request_info['event_end'] ) ? trim( $request_info['event_end'] ) : '';
	$all_day = isset( $request_info['all_day'] ) && !empty( $request_info['all_day'] ) ? true : false;
	$starttime = isset( $request_info['starttime'] ) && !$all_day ? trim( $request_info['starttime'] ) : '';
	$endtime = isset( $request_info['endtime'] ) && !$all_day ? trim( $request_info['endtime'] ) : '';
	$repeat_days = array();
	$repeat_weeks = array();
	
	// recurring event
	if ( $recurring_pkg && $is_recurring ) {
		$repeat_type = isset( $request_info['repeat_type'] ) && in_array( $request_info['repeat_type'], array( 'day', 'week', 'month', 'year', 'custom' ) ) ? $request_info['repeat_type'] : 'custom'; // day, week, month, year, custom
		$different_times = isset( $request_info['different_times'] ) && !empty( $request_info['different_times'] ) ? true : false;
		$starttimes = $different_times && !$all_day && isset( $request_info['starttimes'] ) ? $request_info['starttimes'] : array();
		$endtimes = $different_times && !$all_day && isset( $request_info['endtimes'] ) && !empty( $request_info['endtimes'] ) ? $request_info['endtimes'] : array();

		// week days
		if ( $repeat_type == 'week' || $repeat_type == 'month' ) {
			$repeat_days = isset( $request_info['repeat_days'] ) ? $request_info['repeat_days'] : $repeat_days;
		}
		
		// by week
		if ( $repeat_type == 'month' ) {
			$repeat_weeks = isset( $request_info['repeat_weeks'] ) ? $request_info['repeat_weeks'] : $repeat_weeks;
		}
			
		if ( $repeat_type == 'custom' ) {
			$event_recurring_dates = isset( $request_info['event_recurring_dates'] ) ? trim( $request_info['event_recurring_dates'] ) : '';
			$event_recurring_dates = geodir_event_parse_dates( $event_recurring_dates );
						
			if ( $different_times == 1 ) {
				$starttime = '';
				$endtime = '';
			}
			
			$event_start = !empty( $event_recurring_dates[0] ) ? $event_recurring_dates[0] : $default_start;
			$event_end = $event_start;
			$duration_x = 1;
			
			$repeat_x = 1;
			$repeat_end_type = 0;
			$max_repeat = 1;
			$repeat_end = '';
			
			$event_recurring_dates = !empty( $event_recurring_dates ) ? implode( ',', $event_recurring_dates ) : $event_start;			
		} else {
			$repeat_x = isset( $request_info['repeat_x'] ) ? trim( $request_info['repeat_x'] ) : '';
			$duration_x = isset( $request_info['duration_x'] ) ? trim( $request_info['duration_x'] ) : 1;
			$repeat_end_type = isset( $request_info['repeat_end_type'] ) ? trim( $request_info['repeat_end_type'] ) : 0;
			$event_end = '';
			
			$max_repeat = $repeat_end_type != 1 && isset( $request_info['max_repeat'] ) ? (int)$request_info['max_repeat'] : 1;
			$repeat_end = $repeat_end_type == 1 && isset( $request_info['repeat_end'] ) ? $request_info['repeat_end'] : '';
						
			$repeat_x = $repeat_x > 0 ? (int)$repeat_x : 1;
			$duration_x = $duration_x > 0 ? (int)$duration_x : 1;
			$max_repeat = $max_repeat > 0 ? (int)$max_repeat : 1;
			
			if ( $repeat_end_type == 1 && !geodir_event_is_date( $repeat_end ) ) {
				$repeat_end = '';
			}	
			
			if ( !geodir_event_is_date( $event_start ) ) {
				$event_start = $default_start;
			}
			
			$event_recurring_dates = geodir_event_date_occurrences( $repeat_type, $event_start, $event_end, $repeat_x, $max_repeat, $repeat_end, $repeat_days, $repeat_weeks );
			$event_recurring_dates = !empty( $event_recurring_dates ) ? implode( ",", $event_recurring_dates ) : '';
		}	
	} else {
		if ( !geodir_event_is_date( $event_start ) ) {
			$event_start = $default_start;
		}
				
		if ( strtotime( $event_end ) < strtotime( $event_start ) ) {
			$event_end = $event_start;
		}
		
		$event_recurring_dates = $event_start;
		
		$starttimes = array();
		$endtimes = array();
		
		$repeat_type = '';
		$repeat_x = '';
		$duration_x = '';
		$repeat_end_type = '';
		$max_repeat = '';
		$repeat_end = '';
		$different_times = false;
	}

	$event_shedule_info = array();
	$event_shedule_info['is_recurring'] = $is_recurring;
	$event_shedule_info['event_start'] = $event_start;
	$event_shedule_info['event_end'] = $event_end;
	$event_shedule_info['event_recurring_dates'] = $event_recurring_dates;
	$event_shedule_info['all_day'] = $all_day;
	$event_shedule_info['starttime'] = $starttime;
	$event_shedule_info['endtime'] = $endtime;
	$event_shedule_info['different_times'] = $different_times;
	$event_shedule_info['starttimes'] = $starttimes;
	$event_shedule_info['endtimes'] = $endtimes;
	$event_shedule_info['repeat_type'] = $repeat_type;
	$event_shedule_info['repeat_x'] = $repeat_x;
	$event_shedule_info['duration_x'] = $duration_x;
	$event_shedule_info['repeat_end_type'] = $repeat_end_type;
	$event_shedule_info['max_repeat'] = $max_repeat;
	$event_shedule_info['repeat_end'] = $repeat_end;
	$event_shedule_info['repeat_days'] = $repeat_days;
	$event_shedule_info['repeat_weeks'] = $repeat_weeks;
		
	// save post info
	$gd_post_info['is_recurring'] = $is_recurring;
	$gd_post_info['recurring_dates'] = maybe_serialize( $event_shedule_info );
	
	/* --- save businesses --- */
	if ( isset( $request_info['geodir_link_business' ]) ) {
		$gd_post_info['geodir_link_business'] = $request_info['geodir_link_business'];
	}

	// save event dates
	geodir_save_event_schedule( $event_shedule_info, $last_post_id ); // to create event-schedule dates	

	// save post info
	geodir_save_post_info($last_post_id, $gd_post_info);
	
	return $last_post_id;
}

function geodir_getDays($year, $startMonth=1, $startDay=1, $dayOfWeek='', $week_e = '', $check_full_start_year='', $check_full_end_year='') {
	
	$start = new DateTime(
			sprintf('%04d-%02d-%02d', $year, $startMonth, $startDay)
	);
	$start->modify($dayOfWeek);
	$end   = new DateTime(
			sprintf('%04d-12-31', $year)
	);
	$end->modify( '+1 day' );
	
	$interval = new DateInterval('P1W');
	$period   = new DatePeriod($start, $interval, $end);
	
	$dates_array = array();
	
	foreach ($period as $dt) {
		
		$date_explode = explode('-', $dt->format("Y-m-d"));
		
		$get_year = $date_explode[0];
		$get_month = $date_explode[1];
		$get_date = $date_explode[2];
		
		$check_get_date = date_i18n('Y-m-d', strtotime($get_year.'-'.$get_month.'-'.$get_date));
		
		if($get_month <= $startMonth)
		{
			if($week_e == '')
			{
				if($check_get_date <= $check_full_end_year && $check_get_date >= $check_full_start_year)
					$dates_array[] = $dt->format("Y-m-d");
			}
			
			
			$monthName = date_i18n("F", mktime(0, 0, 0, $get_month, 10));
			
			if($week_e != '')
			{
				$date_check = date_i18n("Y-m-d", strtotime("$week_e $dayOfWeek of $monthName $get_year"));
				
				if($date_check <= $check_full_end_year && $date_check >= $check_full_start_year)
					$dates_array[] = $date_check;
				
			}
		}
	
	}
	
	return $result = array_unique($dates_array);
}


function geodir_save_event_schedule( $event_shedule_info = array(), $last_post_id = '' ) {
	global $wpdb;
	
	if ( empty( $event_shedule_info ) || $last_post_id == '' ) {
		return false;
	}

	// Check recurring enabled
	$post_info = geodir_get_post_info( $last_post_id );
	$recurring_pkg = geodir_event_recurring_pkg( $post_info );
	
	$format = geodir_event_date_format();
	$default_start = date_i18n( $format, current_time( 'timestamp' ) );
	
	if ( !$recurring_pkg ) {
		$event_shedule_info['is_recurring'] = false;
	}

	$wpdb->query( $wpdb->prepare( "DELETE FROM " . EVENT_SCHEDULE . " WHERE event_id=%d", array( $last_post_id ) ) );
	
	$event_recurring_dates = array();
	if ( isset( $event_shedule_info['event_recurring_dates'] ) && !empty( $event_shedule_info['event_recurring_dates'] ) ) {
		if ( is_array( $event_shedule_info['event_recurring_dates'] ) ) {
			$event_recurring_dates = $event_shedule_info['event_recurring_dates'];
		} else {
			$event_recurring_dates = explode( ',', $event_shedule_info['event_recurring_dates'] );
		}
	}
	
	// all day
	$all_day = isset( $event_shedule_info['all_day'] ) && !empty( $event_shedule_info['all_day'] ) ? true : false;
	$different_times = isset( $event_shedule_info['different_times'] ) && !empty( $event_shedule_info['different_times'] ) ? true : false;
	$starttime = !$all_day && isset( $event_shedule_info['starttime'] ) ? $event_shedule_info['starttime'] : '';
	$endtime = !$all_day && isset( $event_shedule_info['endtime'] ) ? $event_shedule_info['endtime'] : '';
	$starttimes = !$all_day && isset( $event_shedule_info['starttimes'] ) ? $event_shedule_info['starttimes'] : array();
	$endtimes = !$all_day && isset( $event_shedule_info['endtimes'] ) ? $event_shedule_info['endtimes'] : array();
	
	if ( $event_shedule_info['is_recurring'] ) {		
		if ( !empty( $event_recurring_dates ) ) {
			$duration = isset( $event_shedule_info['duration_x'] ) && (int)$event_shedule_info['duration_x'] > 0 ? (int)$event_shedule_info['duration_x'] : 1;
			$repeat_type = isset( $event_shedule_info['repeat_type'] ) ? $event_shedule_info['repeat_type'] : 'custom';
									
			$recurring = 1;
			$duration--;
		
			$c = 0;
			foreach( $event_recurring_dates as $key => $date ) {
				if ( $repeat_type == 'custom' && $different_times ) {
					$duration = 0;
					$starttime = isset( $starttimes[$c] ) ? $starttimes[$c] : '';
					$endtime = isset( $endtimes[$c] ) ? $endtimes[$c] : '';
				}
				
				if ( $all_day == 1 ) {
					$starttime = '';
					$endtime = '';
				}
				
				$event_enddate = date_i18n( 'Y-m-d', strtotime( $date . ' + ' . $duration . ' day' ) );
				$sql = $wpdb->prepare( "INSERT INTO  " . EVENT_SCHEDULE . " (event_id, event_date, event_enddate, event_starttime, event_endtime, recurring, all_day) VALUES (%d, %s, %s, %s, %s, %d, %d)", array( $last_post_id, $date, $event_enddate, $starttime, $endtime, $recurring, $all_day ) ) ;
				$wpdb->query( $sql );
				$c++;
			}
		}
	} else {		
		$start_date = isset( $event_shedule_info['event_start'] ) ? $event_shedule_info['event_start'] : '';
		$end_date = isset( $event_shedule_info['event_end'] ) ? $event_shedule_info['event_end'] : $start_date;
				
		if ( !geodir_event_is_date( $start_date ) && !empty( $event_recurring_dates ) ) {
			$start_date = $event_recurring_dates[0];
		}
		
		if ( !geodir_event_is_date( $start_date ) ) {
			$start_date = $default_start;
		}
		
		if ( strtotime( $end_date ) < strtotime( $start_date ) ) {
			$end_date = $start_date;
		}
		
		if ( $starttime == '' && !empty( $starttimes ) ) {
			$starttime = $starttimes[0];
			$endtime = $endtimes[0];
		}
		
		if ( $all_day ) {
			$starttime = '';
			$endtime = '';
		}
		$recurring = 0;
		
		$sql = $wpdb->prepare( "INSERT INTO  " . EVENT_SCHEDULE . " (event_id, event_date, event_enddate, event_starttime, event_endtime, recurring, all_day) VALUES (%d, %s, %s, %s, %s, %d, %d)", array( $last_post_id, $start_date, $end_date, $starttime, $endtime, $recurring, $all_day ) ) ;
		$wpdb->query( $sql );
	}
}

function geodir_event_delete_schedule($post_id){

	global $wpdb, $plugin_prefix;
	
	$post_type = get_post_type( $post_id );
	
	$all_postypes = geodir_get_posttypes();
	
	if(!in_array($post_type, $all_postypes))
		return false;
	
	$wpdb->query($wpdb->prepare("DELETE FROM ".EVENT_SCHEDULE." WHERE event_id=%d", array($post_id)));
	
	$table_name = $plugin_prefix.'gd_event_detail';
	
	$wpdb->query($wpdb->prepare("UPDATE ".$table_name." SET geodir_link_business='' WHERE geodir_link_business=%s",array($post_id)));

}

function geodir_event_remove_illegal_htmltags($tags,$pkey){

	if($pkey == 'event_reg_desc'){
		$tags= '<p><a><b><i><em><h1><h2><h3><h4><h5><ul><ol><li><img><div><del><ins><span><cite><code><strike><strong><blockquote>';
	}
		
	return $tags;
}


function geodir_event_loop_filter_where($where) {
	global $wp_query,$query,$wpdb,$geodir_post_type,$table,$condition_date;
	
	$condition = '';
	$current_date = date_i18n('Y-m-d');
	
	if ( get_query_var( 'event_related_id' ) ) {
		if ( get_query_var( 'geodir_event_type' ) == 'feature' ) {
			$condition = " ( event_date >= '" . $current_date . "' OR ( event_date <= '" . $current_date . "' AND event_enddate >= '" . $current_date . "' ) ) ";
		}
		
		if ( get_query_var( 'geodir_event_type' ) == 'past' ) {
			$condition = " event_date <= '" . $current_date . "' ";
		}
			
		if ( get_query_var( 'geodir_event_type' ) == 'upcoming' ) {
			$condition = " ( event_date >= '" . $current_date . "' OR ( event_date <= '" . $current_date . "' AND event_enddate >= '" . $current_date . "' ) ) ";
		}
		
		$where .= " AND " . $table . ".geodir_link_business = " . get_query_var( 'event_related_id' );
	}
	
	if (get_query_var('geodir_event_date_calendar')) {
		$current_year = date_i18n('Y', get_query_var('geodir_event_date_calendar'));
		$current_month = date_i18n('m', get_query_var('geodir_event_date_calendar'));
		
		//$condition = " YEAR(event_date) = ".$current_year." AND MONTH(event_date) = ".$current_month." ";
		$month_start = $current_year . '-' . $current_month . '-01'; // First day of month.
		$month_end = date_i18n( 'Y-m-t', strtotime( $month_start ) ); // Get last day of month.
		
		$condition = "( ( ( '" . $month_start . "' BETWEEN event_date AND event_enddate ) OR ( event_date BETWEEN '" . $month_start . "' AND event_enddate ) ) AND ( ( '" . $month_end . "' BETWEEN event_date AND event_enddate ) OR ( event_enddate BETWEEN event_date AND '" . $month_end . "' ) ) )";
	}	
	
	if ($condition) {
			
		$find_postids = $wpdb->get_var("SELECT GROUP_CONCAT( DISTINCT event_id SEPARATOR \"','\") as event_ids FROM ".EVENT_SCHEDULE." WHERE ".$condition);
		
		$event_ids = "'".$find_postids."'";
		
		if (get_query_var('geodir_event_date_calendar')) {
			$where .= " AND $wpdb->posts.ID IN ($event_ids)";
		} else {
			$where .= " AND $wpdb->posts.ID IN ($event_ids)";
		}
	}
	// for dashboard listing
	$is_geodir_dashbord = isset($_REQUEST['geodir_dashbord']) && $_REQUEST['geodir_dashbord'] ? true : false;
	if ( ( is_main_query() && $geodir_post_type == 'gd_event' && (geodir_is_page('listing') || is_search() || $is_geodir_dashbord) ) || get_query_var('geodir_event_listing_filter')) {
		
		$filter = isset($_REQUEST['etype']) ? $_REQUEST['etype'] : '';
		
		if($filter == '')
			$filter = get_option('geodir_event_defalt_filter');
		
		if(get_query_var('geodir_event_listing_filter'))
			$filter = get_query_var('geodir_event_listing_filter');
		
		if ( $filter == 'today' ) {
			$where .= " AND ( " . EVENT_SCHEDULE . ".event_date = '" . $current_date . "' OR ( " . EVENT_SCHEDULE . ".event_date <= '" . $current_date . "' AND " . EVENT_SCHEDULE . ".event_enddate >= '" . $current_date . "' ) ) ";
		}
			
		if ( $filter == 'upcoming' ) {
			$where .= " AND ( " . EVENT_SCHEDULE . ".event_date >= '" . $current_date . "' OR ( " . EVENT_SCHEDULE . ".event_date <= '" . $current_date . "' AND " . EVENT_SCHEDULE . ".event_enddate >= '" . $current_date . "' ) ) ";
		}
		
		if ( $filter == 'past' ) {
			$where .= " AND " . EVENT_SCHEDULE . ".event_date < '" . $current_date . "' ";
		}

        $where = apply_filters('geodir_event_listing_filter_where', $where, $filter);

		if(isset($_REQUEST['event_start']) && !empty($_REQUEST['event_start']) && !isset($_REQUEST['event_end'])){
		
			$where .= " AND ".EVENT_SCHEDULE.".event_date = '".date_i18n('Y-m-d',strtotime($_REQUEST['event_start']))."' ";	
		
		}else{
		
			if(isset($_REQUEST['event_start']) && !empty($_REQUEST['event_start']))
				$where .= " AND ".EVENT_SCHEDULE.".event_date >= '".date_i18n('Y-m-d',strtotime($_REQUEST['event_start']))."' ";
				
			if(isset($_REQUEST['event_end']) && !empty($_REQUEST['event_end']))
				$where .= " AND ".EVENT_SCHEDULE.".event_date <= '".date_i18n('Y-m-d',strtotime($_REQUEST['event_end']))."' ";
		}
		
		
		
		if(isset($_SESSION['all_near_me'])){
			global $plugin_prefix,$wp_query;
			
			if(!$geodir_post_type){$geodir_post_type = $wp_query->query_vars['post_type'];}
			$table = $plugin_prefix . $geodir_post_type . '_detail';
			$DistanceRadius = geodir_getDistanceRadius(get_option('geodir_search_dist_1'));
			$mylat = $_SESSION['user_lat'];
			$mylon = $_SESSION['user_lon'];
			
			if(isset($_SESSION['near_me_range']) && is_numeric($_SESSION['near_me_range'])){$dist =$_SESSION['near_me_range']; }
			elseif(get_option('geodir_near_me_dist')!=''){$dist = get_option('geodir_near_me_dist');}
			else{ $dist = '200';  }
			
			$lon1 = $mylon-$dist/abs(cos(deg2rad($mylat))*69); 
			$lon2 = $mylon+$dist/abs(cos(deg2rad($mylat))*69);
			$lat1 = $mylat-($dist/69);
			$lat2 = $mylat+($dist/69);
			
			$rlon1 = is_numeric(min($lon1,$lon2)) ? min($lon1,$lon2) : '';
			$rlon2 = is_numeric(max($lon1,$lon2)) ? max($lon1,$lon2) : '';
			$rlat1 = is_numeric(min($lat1,$lat2)) ? min($lat1,$lat2) : '';
			$rlat2 = is_numeric(max($lat1,$lat2)) ? max($lat1,$lat2) : '';
			
			$where .= " AND ( ".$table.".post_latitude between $rlat1 and $rlat2 ) 
						AND ( ".$table.".post_longitude between $rlon1 and $rlon2 ) ";
		}
		
		// filter place for linked events
		$venue = isset( $_REQUEST['venue'] ) ? $_REQUEST['venue'] : '';
		if ( $venue != '' ) {
			$venue = explode( '-', $venue, 2);
			$venue_info = !empty($venue) && isset($venue[0]) ? get_post((int)$venue[0]) : array();
			$link_business_id = !empty( $venue_info ) && isset( $venue_info->ID ) ? (int)$venue_info->ID : '-1';
			
			$where .= " AND " . $table . ".geodir_link_business = " . (int)$link_business_id;
		}		
	}
	
	if ( is_search() && isset( $_REQUEST['geodir_search'] ) && isset( $_REQUEST['event_calendar'] ) && is_main_query() ) {
		$condition_date = substr( $_REQUEST['event_calendar'], 0, 4 ) . '-' . substr( $_REQUEST['event_calendar'] , 4, 2 ) . '-' . substr( $_REQUEST['event_calendar'], 6, 2 );
		$filter_date =  date_i18n( 'Y-m-d', strtotime( $condition_date ) );
		$condition = " ( event_date = '" . $filter_date . "' OR ( event_date <= '" . $filter_date . "' AND event_enddate >= '" . $filter_date . "' ) ) ";
		
		if ( $condition ) {
			$where .= " AND $condition ";
		}
	}
	
	return $where;
}

function geodir_event_date_calendar_fields( $fields ) {
	global $query, $wp_query, $wpdb, $geodir_post_type, $table, $plugin_prefix;
	
	if ( !empty( $geodir_post_type ) && $geodir_post_type != 'gd_event' ) {
		return $fields;
	}
	
	$schedule_table = EVENT_SCHEDULE;
		
	if ( get_query_var( 'geodir_event_date_calendar' ) ) {
		$current_year = date_i18n( 'Y', get_query_var( 'geodir_event_date_calendar' ) );
		$current_month = date_i18n( 'm', get_query_var( 'geodir_event_date_calendar' ) );
		//$condition = " YEAR(event_date) = ".$current_year." AND MONTH(event_date) = ".$current_month." AND " . $schedule_table . ".event_id = " . $wpdb->posts . ".ID ";
		$month_start = $current_year . '-' . $current_month . '-01'; // First day of the month.
		$month_end = date_i18n( 'Y-m-t', strtotime( $month_start ) ); // Last day of the month.
		
		$condition = "( ( ( '" . $month_start . "' BETWEEN event_date AND event_enddate ) OR ( event_date BETWEEN '" . $month_start . "' AND event_enddate ) ) AND ( ( '" . $month_end . "' BETWEEN event_date AND event_enddate ) OR ( event_enddate BETWEEN event_date AND '" . $month_end . "' ) ) ) AND " . $schedule_table . ".event_id = " . $wpdb->posts . ".ID";
		
		$fields = " ( SELECT GROUP_CONCAT( DISTINCT CONCAT( DATE( " . $schedule_table . ".event_date ), '_', " . $schedule_table . ".event_enddate ) ) FROM " . $schedule_table . " WHERE " . $condition . " ) AS event_dates";
	} else {
		if ( ( is_main_query() && ( geodir_is_page( 'listing' ) || ( is_search() && isset($_REQUEST['geodir_search'])) || isset($_REQUEST['geodir_dashbord'] ) ) ) || get_query_var( 'geodir_event_listing_filter' ) ) {
			$fields .= ", ".$table.".*".", ".EVENT_SCHEDULE.".* ";
		}
	}	
	
	if(isset($_SESSION['all_near_me'])){
			$DistanceRadius = geodir_getDistanceRadius(get_option('geodir_search_dist_1'));
			$mylat = $_SESSION['user_lat'];
			$mylon = $_SESSION['user_lon'];
			
			
			
			$fields .= " , (".$DistanceRadius." * 2 * ASIN(SQRT( POWER(SIN((ABS($mylat) - ABS(".$table.".post_latitude)) * pi()/180 / 2), 2) +COS(ABS($mylat) * pi()/180) * COS( ABS(".$table.".post_latitude) * pi()/180) *POWER(SIN(($mylon - ".$table.".post_longitude) * pi()/180 / 2), 2) )))as distance ";
		}
	
	return $fields;
}


function geodir_event_date_calendar_join($join)
{
	global $wpdb,$query,$geodir_post_type,$table,$table_prefix,$plugin_prefix, $gdevents_widget;
	
	if ( !empty( $geodir_post_type ) && $geodir_post_type != 'gd_event' ) {
		return $join;
	}
	
	$schedule_table = EVENT_SCHEDULE;
	if(((is_main_query() && (geodir_is_page('listing') || ( is_search() && isset($_REQUEST['geodir_search'])))) || get_query_var('geodir_event_date_calendar') || isset($_REQUEST['geodir_dashbord'])) || get_query_var('geodir_event_listing_filter')){
		if ( !geodir_is_geodir_page() && $gdevents_widget ) {
			$geodir_post_type = 'gd_event';
			$table = $plugin_prefix . $geodir_post_type . '_detail';
			$join .= " INNER JOIN ".$table." ON (".$table.".post_id = $wpdb->posts.ID)  " ;
		}
		$join .= " INNER JOIN ".$schedule_table." ON (".$schedule_table.".event_id = $wpdb->posts.ID)  " ;
	}

	return $join;
}


function geodir_event_posts_order_by_sort($orderby, $sort_by, $table){
	global $query, $geodir_post_type,$wpdb;
	
	if ( !empty( $geodir_post_type ) && $geodir_post_type != 'gd_event' ) {
		return $orderby;
	}
	
	if(((is_main_query() && (geodir_is_page('listing') || ( is_search() && isset($_REQUEST['geodir_search']))) || get_query_var('geodir_event_date_calendar') || isset($_REQUEST['geodir_dashbord']))) || get_query_var('geodir_event_listing_filter')){
	
		$orderby .= " ".$wpdb->prefix."geodir_event_schedule.event_date asc,  ".$wpdb->prefix."geodir_event_schedule.event_starttime asc , ";
		
	}
	
	return $orderby;
	
}

function geodir_event_posts_order_by_sort_distance($orderby){
	global $query, $geodir_post_type,$wpdb;
	
	if ( !empty( $geodir_post_type ) && $geodir_post_type != 'gd_event' ) {
		return $orderby;
	}
	
	if (get_query_var('geodir_event_listing_filter') && get_query_var('order_by')) {
		global $gd_query_args, $query_vars, $wp_query;
		
		$gd_query_args = isset($wp_query->query) ? $wp_query->query : array();
		
		$orderby = geodir_event_widget_events_get_order( array( 'order_by' => get_query_var('order_by') ) );
		$orderby .= " " . EVENT_DETAIL_TABLE . ".is_featured";
	}
	return $orderby;
	
	if(((is_main_query() && (geodir_is_page('listing') || ( is_search() && isset($_REQUEST['geodir_search']))) || get_query_var('geodir_event_date_calendar') || isset($_REQUEST['geodir_dashbord']))) || get_query_var('geodir_event_listing_filter')){
	
		if(isset($_SESSION['all_near_me'])){
		$orderby =	" distance, ".$orderby;
		}
		
	}
	
	return $orderby;
	
}

/**
 * Filter the GROUP BY clause of the event listings query.
 *
 * @since 1.0.0
 * @since 1.2.4 Added global $gdevents_widget.
 *
 * @global object $wp_query WordPress Query object.
 * @global WP_Query $query The WP_Query instance.
 * @global object $wpdb WordPress Database object.
 * @param string $geodir_post_type The post type.
 * @param string $table The table name. Ex: geodir_countries.
 * @param string $condition_date The parameter for date filter.
 * @param bool $gdevents_widget True if event widget, otherwise false.
 *
 * @param string   $groupby The GROUP BY clause of the query.
 * @param WP_Query $q   The WP_Query instance.
 * @return The GROUP BY clause.
*/
function geodir_event_loop_filter_groupby( $groupby, $q ) {
	global $wp_query, $query, $wpdb, $geodir_post_type, $table, $condition_date, $gdevents_widget;
	
	if ($geodir_post_type == 'gd_event' && ((is_main_query() && geodir_is_page('listing') && (isset($q->query['gd_is_geodir_page']) && $q->query['gd_is_geodir_page'])) || $gdevents_widget)) {
		$groupby = " $wpdb->posts.ID," . EVENT_SCHEDULE . ".event_date";
	} else if (get_query_var('geodir_event_date_calendar')){
		$groupby = ' event_id';
	}
	
	return $groupby;
}

function geodir_event_loop_filter($query){
	
	global $wp_query,$geodir_post_type;
	
	if ( is_admin() && ( !defined('DOING_AJAX' ) || ( defined('DOING_AJAX') && !DOING_AJAX ) ) ) {
		return $query;
	}

    $geodir_post_type = geodir_get_current_posttype();

    $post_types = geodir_get_posttypes();
	
	if ( in_array($geodir_post_type, $post_types) && isset($query->query_vars['is_geodir_loop']) && $query->query_vars['is_geodir_loop'] && ($geodir_post_type=='gd_event' || get_query_var('geodir_event_date_calendar') || get_query_var('geodir_event_listing_filter'))) {
		
			add_filter('posts_fields', 'geodir_event_date_calendar_fields' ,1 );
			add_filter('posts_join', 'geodir_event_date_calendar_join',1);
			add_filter('geodir_posts_order_by_sort', 'geodir_event_posts_order_by_sort', 2, 3);
			add_filter('posts_where', 'geodir_event_loop_filter_where', 2);
			add_filter('posts_groupby', 'geodir_event_loop_filter_groupby',10,2 );
			add_filter('posts_orderby', 'geodir_event_posts_order_by_sort_distance', 10 );
	}else{
        remove_filter('posts_fields', 'geodir_event_date_calendar_fields' ,1 );
        remove_filter('posts_join', 'geodir_event_date_calendar_join',1);
        remove_filter('geodir_posts_order_by_sort', 'geodir_event_posts_order_by_sort', 2, 3);
        remove_filter('posts_where', 'geodir_event_loop_filter_where', 2);
        remove_filter('posts_groupby', 'geodir_event_loop_filter_groupby',10,2 );
        remove_filter('posts_orderby', 'geodir_event_posts_order_by_sort_distance', 10 );
    }
	
	return $query;
}


function geodir_event_cat_post_count_join($join,$post_type){
	global $plugin_prefix;
	if($post_type == 'gd_event')
	{
		$join .= ", ".$plugin_prefix."event_schedule sch ";
	}
	
	return $join;
}

add_filter('geodir_cat_post_count_join', 'geodir_event_cat_post_count_join', 1, 2);

function geodir_event_cat_post_count_where( $where, $post_type ) {
	global $plugin_prefix;
	
	$current_date = date_i18n( 'Y-m-d' );
	
	if ( $post_type == 'gd_event' ) {
		$table_name = $plugin_prefix . $post_type . '_detail';
		$where .= " AND " . $table_name . ".post_id=sch.event_id AND ( sch.event_date >= '" . $current_date . "' OR ( sch.event_date <= '" . $current_date . "' AND sch.event_enddate >= '" . $current_date . "' ) ) ";
	}
	
	return $where;
}

add_filter('geodir_cat_post_count_where', 'geodir_event_cat_post_count_where',1 ,2);

function geodir_event_fill_listings( $term ) {
	//$listings = geodir_event_get_my_listings( 'gd_place', $term );
	$listings = geodir_event_get_my_listings( 'all', $term );
	$options = '<option value="">' . __( 'No Business', 'geodirevents' ) . '</option>';
	if( !empty( $listings ) ) {
		foreach( $listings as $listing ) {
			$options .= '<option value="' . $listing->ID . '">' . $listing->post_title . '</option>';
		}
	}
	return $options;
}

function geodir_event_manager_ajax(){

	$task = isset( $_REQUEST['task'] ) ? $_REQUEST['task'] : '';
	switch( $task ) {
		case 'geodir_fill_listings' :
			$term = isset( $_REQUEST['term'] ) ? $_REQUEST['term'] : '';
			echo geodir_event_fill_listings( $term );
			exit;
		break;
	}
	
	if(isset($_REQUEST['event_type']) && $_REQUEST['event_type'] == 'calendar'){
		geodir_event_display_calendar(); exit;
	}

	if(isset($_REQUEST['gd_event_general_settings'])){
		geodir_update_options( geodir_event_general_setting_options() );
		
		$msg = 'Your settings have been saved.';
		
		$msg = urlencode($msg);
		
			$location = admin_url()."admin.php?page=geodirectory&tab=gd_event_fields_settings&subtab=gd_event_general_options&event_success=".$msg;
		wp_redirect($location);
		exit;
		
	}
	
	if(isset($_REQUEST['auto_fill']) && $_REQUEST['auto_fill'] == 'geodir_business_autofill'){
		
		if(isset($_REQUEST['place_id']) && $_REQUEST['place_id'] != '' && isset($_REQUEST['_wpnonce']))
		{
			
			if ( !wp_verify_nonce( $_REQUEST['_wpnonce'], 'geodir_link_business_autofill_nonce' ) )
						exit;
			
			geodir_business_auto_fill($_REQUEST);
			exit;
			
		}else{
		
			wp_redirect(home_url().'/?geodir_signup=true');
			exit();
		}
		
	}
	
}

function geodir_business_auto_fill($request){

	if(!empty($request)){
		
		$place_id = $request['place_id'];
		$post_type = get_post_type( $place_id );
		$package_id = geodir_get_post_meta($place_id,'package_id',true);
		$custom_fields = geodir_post_custom_fields($package_id,'all',$post_type); 
		
		$json_array = array();
		
		$content_post = get_post($place_id);
		$content = $content_post->post_content;
		
		$json_array['post_title'] = array('key' => 'text',
																			'value' => geodir_get_post_meta($place_id,'post_title',true));
		
		$json_array['post_desc'] = array(	'key' => 'textarea', 
																			'value' => $content);
		
		
		foreach($custom_fields as $key=>$val){
			
			$type = $val['type'];
			
			switch($type){
			
				case 'phone':
				case 'email':
				case 'text':
				case 'url':					
					$value = geodir_get_post_meta($place_id,$val['htmlvar_name'],true);
					$json_array[$val['htmlvar_name']] = array('key' => 'text', 'value' => $value);
					
				break;
				
				case 'html':
				case 'textarea':
					
					$value = geodir_get_post_meta($place_id,$val['htmlvar_name'],true);
					$json_array[$val['htmlvar_name']] = array('key' => 'textarea', 'value' => $value);
					
				break;
				
				case 'address':
					
					$json_array['post_address'] = array('key' => 'text',
																			'value' => geodir_get_post_meta($place_id,'post_address',true));
					$json_array['post_zip'] = array('key' => 'text',
																			'value' => geodir_get_post_meta($place_id,'post_zip',true));
					$json_array['post_latitude'] = array('key' => 'text',
																			'value' => geodir_get_post_meta($place_id,'post_latitude',true));
					$json_array['post_longitude'] = array('key' => 'text',
																			'value' => geodir_get_post_meta($place_id,'post_longitude',true));
					
					
					$extra_fields = unserialize($val['extra_fields']);
					
					$show_city = isset($extra_fields['show_city']) ? $extra_fields['show_city'] : '';
					
					if($show_city){

						$json_array['post_country'] = array('key' => 'text',
																				'value' => geodir_get_post_meta($place_id,'post_country',true));
						$json_array['post_region'] = array('key' => 'text',
																				'value' => geodir_get_post_meta($place_id,'post_region',true));
						$json_array['post_city'] = array('key' => 'text',
																			'value' => geodir_get_post_meta($place_id,'post_city',true));
						
					}
					
					
				break;
				case 'checkbox':
				case 'radio':
				case 'select':
				case 'datepicker':
				case 'time':
					$value = geodir_get_post_meta( $place_id, $val['htmlvar_name'], true );
					$json_array[$val['htmlvar_name']] = array( 'key' => $type, 'value' => $value );
				break;
				case 'multiselect':
					$value = geodir_get_post_meta( $place_id, $val['htmlvar_name'] );
					$value = $value != '' ? explode( ",", $value ) : array();
					$json_array[$val['htmlvar_name']] = array( 'key' => $type, 'value' => $value );
				break;
				
			}
			
		}

	}
	
	if ( !empty( $json_array ) ) {
		// attach terms
		$post_tags = wp_get_post_terms( $place_id, $post_type . '_tags', array( "fields" => "names" ) );
		$post_tags = !empty( $post_tags ) && is_array( $post_tags ) ? implode( ",", $post_tags ) : '';
		$json_array['post_tags'] = array( 'key' => 'tags', 'value' => $post_tags );
		
		echo json_encode( $json_array );
	}	
}


function geodir_wp_default_date_time_format()
{
	return get_option('date_format'). ' ' .	get_option('time_format');
}

function geodir_get_cal_trans_array()
{

	$cal_trans = array('month_long_1' => __( 'January','geodirevents' ),
'month_long_2' => __( 'February','geodirevents' ),
'month_long_3' => __( 'March','geodirevents' ),
'month_long_4' => __( 'April','geodirevents' ),
'month_long_5' => __( 'May','geodirevents' ),
'month_long_6' => __( 'June','geodirevents' ),
'month_long_7' => __( 'July','geodirevents' ),
'month_long_8' => __( 'August','geodirevents' ),
'month_long_9' => __( 'September','geodirevents' ),
'month_long_10' => __( 'October' ,'geodirevents'),
'month_long_11' => __( 'November' ,'geodirevents'),
'month_long_12' => __( 'December' ,'geodirevents'),
'month_s_1' => __( 'Jan','geodirevents' ),
'month_s_2' => __( 'Feb','geodirevents' ),
'month_s_3' => __( 'Mar','geodirevents' ),
'month_s_4' => __( 'Apr' ,'geodirevents'),
'month_s_5' => __( 'May' ,'geodirevents'),
'month_s_6' => __( 'Jun' ,'geodirevents'),
'month_s_7' => __( 'Jul','geodirevents' ),
'month_s_8' => __( 'Aug' ,'geodirevents'),
'month_s_9' => __( 'Sep' ,'geodirevents'),
'month_s_10' => __( 'Oct' ,'geodirevents'),
'month_s_11' => __( 'Nov','geodirevents' ),
'month_s_12' => __( 'Dec','geodirevents' ),
'day_s1_1' => __( 'S' ,'geodirevents'),
'day_s1_2' => __( 'M' ,'geodirevents'),
'day_s1_3' => __( 'T' ,'geodirevents'),
'day_s1_4' => __( 'W' ,'geodirevents'),
'day_s1_5' => __( 'T' ,'geodirevents'),
'day_s1_6' => __( 'F' ,'geodirevents'),
'day_s1_7' => __( 'S' ,'geodirevents'),
'day_s2_1' => __( 'Su' ,'geodirevents'),
'day_s2_2' => __( 'Mo' ,'geodirevents'),
'day_s2_3' => __( 'Tu','geodirevents' ),
'day_s2_4' => __( 'We','geodirevents' ),
'day_s2_5' => __( 'Th','geodirevents' ),
'day_s2_6' => __( 'Fr' ,'geodirevents'),
'day_s2_7' => __( 'Sa' ,'geodirevents'),
'day_s3_1' => __( 'Sun','geodirevents' ),
'day_s3_2' => __( 'Mon' ,'geodirevents'),
'day_s3_3' => __( 'Tue' ,'geodirevents'),
'day_s3_4' => __( 'Wed','geodirevents' ),
'day_s3_5' => __( 'Thu' ,'geodirevents'),
'day_s3_6' => __( 'Fri' ,'geodirevents'),
'day_s3_7' => __( 'Sat' ,'geodirevents'),
'day_s5_1' => __( 'Sunday','geodirevents' ),
'day_s5_2' => __( 'Monday' ,'geodirevents'),
'day_s5_3' => __( 'Tuesday','geodirevents' ),
'day_s5_4' => __( 'Wednesday','geodirevents' ),
'day_s5_5' => __( 'Thursday','geodirevents' ),
'day_s5_6' => __( 'Friday' ,'geodirevents'),
'day_s5_7' => __( 'Saturday' ,'geodirevents'),

's_previousMonth' => __( 'Previous Month' ),
's_nextMonth' => __( 'Next Month' ),
's_close' => __( 'Close' ));

return $cal_trans;
}

function geodir_event_link_businesses( $post_id, $post_type, $arr = false ) {
	global $wpdb, $plugin_prefix;
	
	$table = $plugin_prefix . 'gd_event_detail';
	
	$sql = $wpdb->prepare(
		"SELECT post_id FROM " . $table . " WHERE post_status=%s AND geodir_link_business=%d", array( 'publish', $post_id )
	);
	
	$rows = $wpdb->get_results($sql);
	
	$result = array();
	if ( !empty( $rows ) ) {
		foreach ($rows as $row) {
			$result[] = $row->post_id;
		}
	}
		
	return $result;
}

function geodir_event_link_businesses_data( $post_ids, $event_type = 'all', $list_sort = 'latest', $post_number = 5 ) {
	global $wpdb, $plugin_prefix;
	
	$table = $plugin_prefix . 'gd_event_detail';
	if ( $post_ids == '' || ( is_array( $post_ids ) && empty( $post_ids ) ) ) {
		return NULL;
	}
	$post_ids = is_array( $post_ids ) ? implode( "','", $post_ids ) : '';
	
	$current_date = date_i18n( 'Y-m-d', current_time( 'timestamp' ) );
	$limit = $post_number < 1 || $post_number > 100 ? 5 : $post_number;
	
	$orderby = geodir_event_widget_events_get_order( array( 'order_by' => $list_sort ) );
	
	if ($list_sort == 'upcoming') {
		$orderby = '';
	} 
	
	$where = '';
	switch( $event_type ) {
		case 'today':
			$where .= " AND ( " . EVENT_SCHEDULE . ".event_date LIKE '" . $current_date . "%%' OR ( " . EVENT_SCHEDULE . ".event_date <= '" . $current_date . "' AND " . EVENT_SCHEDULE . ".event_enddate >= '" . $current_date . "' ) ) ";
		break;
		case 'upcoming':
			$where .= " AND ( " . EVENT_SCHEDULE . ".event_date >= '" . $current_date . "' OR ( " . EVENT_SCHEDULE . ".event_date <= '" . $current_date . "' AND " . EVENT_SCHEDULE . ".event_enddate >= '" . $current_date . "' ) ) ";
		break;
		case 'past':
			$where .= " AND " . EVENT_SCHEDULE . ".event_date < '" . $current_date . "' ";
		break;
	}

	$sql =  $wpdb->prepare( "SELECT SQL_CALC_FOUND_ROWS " . $wpdb->posts . ".*, " . $table . ".*, " . EVENT_SCHEDULE . ".*
		FROM " . $wpdb->posts . "
		INNER JOIN " . $table ." ON (" . $table . ".post_id = " . $wpdb->posts . ".ID)
		INNER JOIN " . EVENT_SCHEDULE . " AS " . EVENT_SCHEDULE . " ON (" . EVENT_SCHEDULE . ".event_id = " . $wpdb->posts . ".ID)
		WHERE " . $wpdb->posts . ".ID IN ('" . $post_ids . "')
			AND " . $wpdb->posts . ".post_type = 'gd_event'
			AND " . $wpdb->posts . ".post_status = 'publish'
			" . $where . "
		ORDER BY " . $orderby . " (CASE WHEN DATEDIFF(DATE(" . EVENT_SCHEDULE . ".event_date), '" . $current_date . "') < 0 THEN 1 ELSE 0 END), ABS(DATEDIFF(DATE(" . EVENT_SCHEDULE . ".event_date), '" . $current_date . "')) ASC, " . EVENT_SCHEDULE . ".event_starttime ASC, " . $table . ".is_featured ASC, " . $wpdb->posts . ".post_title ASC
		LIMIT %d", array( $limit) );

	$rows = $wpdb->get_results($sql);
	
	return $rows;
}

function geodir_event_display_link_business() {
	global $post;
	$post_type = geodir_get_current_posttype();
	$all_postypes = geodir_get_posttypes();
		
	if ( !empty( $post ) && $post_type == 'gd_event' && geodir_is_page( 'detail' ) && isset( $post->geodir_link_business ) && !empty( $post->geodir_link_business ) ) {
		$linked_post_id = $post->geodir_link_business;
		$linked_post_info = get_post($linked_post_id);
		if( !empty( $linked_post_info ) ) {
			$linked_post_type_info = in_array( $linked_post_info->post_type, $all_postypes ) ? geodir_get_posttype_info( $linked_post_info->post_type )  : array();
			if( !empty( $linked_post_type_info ) ) {
				$linked_post_title = !empty( $linked_post_info->post_title ) ? $linked_post_info->post_title : __( 'Listing', 'geodirevents' );
				$linked_post_url = get_permalink($linked_post_id);
				
				$html_link_business = '<div class="geodir_more_info geodir_more_info_even geodir_link_business"><span class="geodir-i-website"><i class="fa fa-link"></i> <a title="' . esc_attr( $linked_post_title ) . '" href="'.$linked_post_url.'">' . wp_sprintf( __( 'Go to: %s', 'geodirevents' ), $linked_post_title ) . '</a></span></div>';
				
				echo apply_filters( 'geodir_more_info_link_business', $html_link_business, $linked_post_id, $linked_post_url );
			}
		}
	}
}

function geodir_event_get_my_listings( $post_type = 'all', $search = '', $limit = 5 ) {
	global $wpdb, $current_user;
	
	if( empty( $current_user->ID ) ) {
		return NULL;
	} 
	$geodir_postypes = geodir_get_posttypes();

	$search = trim( $search );
	$post_type = $post_type != '' ? $post_type : 'all';
	
	if( $post_type == 'all' ) {
		$geodir_postypes = implode( ",", $geodir_postypes );
		$condition = $wpdb->prepare( " AND FIND_IN_SET( post_type, %s )" , array( $geodir_postypes ) );
	} else {
		$post_type = in_array( $post_type, $geodir_postypes ) ? $post_type : 'gd_place';
		$condition = $wpdb->prepare( " AND post_type = %s" , array( $post_type ) );
	}
	$condition .= !current_user_can( 'manage_options' ) ? $wpdb->prepare( "AND post_author=%d" , array( (int)$current_user->ID ) ) : '';
	$condition .= $search != '' ? $wpdb->prepare( " AND post_title LIKE %s", array( $search . '%%' ) ) : "";
	
	$orderby = " ORDER BY post_title ASC";
	$limit = " LIMIT " . (int)$limit;
	
	$sql = $wpdb->prepare( "SELECT ID, post_title FROM $wpdb->posts WHERE post_status = %s AND post_type != 'gd_event' " . $condition . $orderby . $limit, array( 'publish' ) );
	$rows = $wpdb->get_results($sql);
	
	return $rows;
}

add_filter('geodir_filter_widget_listings_fields','geodir_filter_event_widget_listings_fields',10,3);
function geodir_filter_event_widget_listings_fields($fields,$table,$post_type){
	global $plugin_prefix;
	if($post_type=='gd_event'){
	$fields .= ", ".EVENT_SCHEDULE.".* ";	
	}
	return $fields;
}

add_filter('geodir_filter_widget_listings_join','geodir_filter_event_widget_listings_join',10,2);
function geodir_filter_event_widget_listings_join($join,$post_type){
	global $plugin_prefix,$wpdb;
	if($post_type=='gd_event'){
	$join .= " INNER JOIN ".EVENT_SCHEDULE." ON (".EVENT_SCHEDULE.".event_id = $wpdb->posts.ID) ";	
	}
	return $join;
}

add_filter( 'geodir_filter_widget_listings_where', 'geodir_filter_event_widget_listings_where', 10, 2 );
function geodir_filter_event_widget_listings_where( $where, $post_type ) {
	global $plugin_prefix, $wpdb;
	
	if ( $post_type == 'gd_event' ) {
		$where .= " AND ( " . EVENT_SCHEDULE . ".event_date >= '" . date_i18n( 'Y-m-d' ) . "' OR ( " . EVENT_SCHEDULE . ".event_date <= '" . date_i18n( 'Y-m-d' ) . "' AND " . EVENT_SCHEDULE . ".event_enddate >= '" . date_i18n( 'Y-m-d' ) . "' ) ) ";
	}
	return $where;
}

add_filter('geodir_filter_widget_listings_orderby','geodir_filter_event_widget_listings_orderby',10,3);
function geodir_filter_event_widget_listings_orderby($orderby,$table,$post_type){
	global $plugin_prefix,$wpdb;
	if($post_type=='gd_event'){
	$orderby = " ".EVENT_SCHEDULE.".event_date asc,".EVENT_SCHEDULE.".event_starttime asc , ".EVENT_DETAIL_TABLE.".is_featured asc, $wpdb->posts.post_date desc, ";	
	}
	return $orderby;
}

function geodir_event_postview_output($args='', $instance='')
{
	// prints the widget
	extract($args, EXTR_SKIP);

	echo $before_widget;

	global $gdevents_widget;
	$gdevents_widget = true;

	$title = empty($instance['title']) ? ucwords($instance['category_title']) : apply_filters('widget_title', __($instance['title'],'geodirevents'));

	$post_type = 'gd_event';

	$category = empty($instance['category']) ? '0' : apply_filters('widget_category', $instance['category']);

	$post_number = empty($instance['post_number']) ? '5' : apply_filters('widget_post_number', $instance['post_number']);

	$layout = empty($instance['layout']) ? 'gridview_onehalf' : apply_filters('widget_layout', $instance['layout']);

	$add_location_filter = empty($instance['add_location_filter']) ? '0' : apply_filters('widget_layout', $instance['add_location_filter']);

	$listing_width = empty($instance['listing_width']) ? '' : apply_filters('widget_layout', $instance['listing_width']);

	$list_sort = empty($instance['list_sort']) ? 'latest' : apply_filters('widget_list_sort', $instance['list_sort']);

	$list_filter = empty($instance['list_filter']) ? 'all' : apply_filters('widget_list_filter', $instance['list_filter']);

	if(isset($instance['character_count'])){$character_count = apply_filters('widget_list_character_count', $instance['character_count']);}
	else{$character_count ='';}
	
	$category = is_array($category) ? $category : explode(",", $category);

	if(empty($title) || $title == 'All' ){
		$title .= ' '.get_post_type_plural_label($post_type);
	}

	$location_url = '';

	$location_url = array();
	$city = get_query_var('gd_city');
	if( !empty($city) ){

		if(get_option('geodir_show_location_url') == 'all'){
			$country = get_query_var('gd_country');
			$region = get_query_var('gd_region');
			if(!empty($country))
				$location_url[] = $country;

			if(!empty($region))
				$location_url[] = $region;
		}
		$location_url[] = $city;
	}

	$location_url = implode("/",$location_url);
	
	$skip_location = false;
	if (!$add_location_filter && !empty($_SESSION['gd_multi_location'])) {
		$skip_location = true;
		unset($_SESSION['gd_multi_location']);
	}

	if ( get_option('permalink_structure') )
		$viewall_url = get_post_type_archive_link($post_type);
	else
		$viewall_url = get_post_type_archive_link($post_type);


	if(!empty($category) && $category[0] != '0'){
		global $geodir_add_location_url;
		$geodir_add_location_url = '0';
		if($add_location_filter != '0'){
			$geodir_add_location_url = '1';
		}
		$viewall_url = get_term_link( (int)$category[0], $post_type.'category');
		$geodir_add_location_url = NULL;
	}
	if ($skip_location) {
		$_SESSION['gd_multi_location'] = 1;
	}

	?>
	<div class="geodir_locations geodir_location_listing">
		<?php do_action('geodir_before_view_all_link_in_widget') ; ?>
		<div class="geodir_list_heading clearfix">
			<?php echo $before_title.$title.$after_title;?>
			<a href="<?php echo $viewall_url;?>" class="geodir-viewall">
				<?php _e('View all','geodirevents');?>
			</a>
		</div>
		<?php do_action('geodir_after_view_all_link_in_widget') ; ?>
		<?php
		$query_args = array(
			'posts_per_page' => $post_number,
			'is_geodir_loop' => true,
			'gd_location' 	 => ($add_location_filter) ? true : false,
			'post_type' => $post_type,
			'geodir_event_listing_filter' => $list_filter,
			'order_by' =>$list_sort,
			'excerpt_length' => $character_count,
		);

		if(!empty($category) && $category[0] != '0'){

			$category_taxonomy = geodir_get_taxonomies($post_type);

			######### WPML #########
			if(function_exists('icl_object_id')) {
				$category = gd_lang_object_ids($category, $category_taxonomy[0]);
			}
			######### WPML #########

			$tax_query = array( 'taxonomy' => $category_taxonomy[0],
				'field' => 'id',
				'terms' => $category);

			$query_args['tax_query'] = array( $tax_query );
		}

		global $gridview_columns;
		query_posts( $query_args );

		if(strstr($layout,'gridview')){

			$listing_view_exp = explode('_',$layout);

			$gridview_columns = $layout;

			$layout = $listing_view_exp[0];

		}

		$template = apply_filters( "geodir_template_part-listing-listview", geodir_plugin_path() . '/geodirectory-templates/listing-listview.php' );

		include( $template );

		wp_reset_query();
		?>

	</div>


	<?php
	$gdevents_widget = NULL;
	unset( $gdevents_widget );
	echo $after_widget;

}


function geodir_event_calendar_widget_output($args='', $instance='')
{
	global $post;
	extract($args, EXTR_SKIP);

	$title = empty($instance['title']) ? '' : apply_filters('widget_title', $instance['title']);
	$day = empty($instance['day']) ? '' : apply_filters('widget_day', $instance['day']);
	$week_day_format = empty($instance['week_day_format']) ? 0 : apply_filters('widget_week_day_format', $instance['week_day_format']);

	add_action( 'wp_enqueue_scripts', 'geodir_event_calenders_script' );

	echo $before_widget;

	?>

	<div class="geodir_event_cal_widget">

		<?php if(trim($title) != ''){ ?>
			<div class="geodir_event_cal_widget_title clearfix">
				<h3><?php echo $before_title.__($title, 'geodirevents').$after_title;?></h3>
			</div>
		<?php } ?>

		<table width="100%" class="gd_cal_nav">
			<tr align="center" class="title">
				<td width="10%" class="title" ><img class="geodir_cal_prev" src="<?php echo plugins_url('gdevents-assets/images/previous2.png', __FILE__); ?>" alt=""  /></td>

				<td   class="title" ><center><img class="geodir_event_loading"  src="<?php echo plugins_url('gdevents-assets/images/ajax-loader.gif', __FILE__); ?>" /></strong></center></td>

				<td width="10%" class="title" ><img  class="geodir_cal_next"  src="<?php echo plugins_url('gdevents-assets/images/next2.png', __FILE__) ; ?>" alt=""  /></td>
			</tr>
		</table>

		<div class="geodir_event_calendar"></div>

	</div>

	<script type="text/javascript">
		if(typeof myfunction !== 'function') {
			window.geodir_event_call_calendar = function () {
				//function geodir_event_call_calendar(){

				var sday = '<?php echo $day; ?>';
				var wday = '<?php echo (int)$week_day_format; ?>';

				var myurl = "<?php echo geodir_event_manager_ajaxurl().'&event_type=calendar'; ?>" + "&sday=" + sday + "&wday=" + wday;

				jQuery.ajax({
					type: "GET",
					url: myurl,
					success: function (msg) {
						jQuery('.geodir_event_loading').hide();
						jQuery(".geodir_event_calendar").html(msg);
						//jQuery("#cal_title").detach().insertBefore("#geodir_event_loading");
					}
				});

				var mnth = <?php echo date_i18n("n"); ?>;
				var year = <?php echo date_i18n("Y"); ?>;

				jQuery(".geodir_cal_next").click(function () {

					jQuery('.geodir_event_loading').show();
					mnth++;
					if (mnth > 12) {
						year++;
						mnth = 1;
					}

					var nexturl = "<?php echo geodir_event_manager_ajaxurl().'&event_type=calendar'; ?>&mnth=" + mnth + "&yr=" + year + "&sday=" + sday + "&wday=" + wday;
					jQuery.ajax({
						type: "GET",
						url: nexturl,
						success: function (next) {
							jQuery('.geodir_event_loading').hide();
							jQuery(".geodir_event_calendar").html(next);
						}
					});

				});

				jQuery(".geodir_cal_prev").click(function () {

					jQuery('.geodir_event_loading').show();
					mnth--;

					if (mnth < 1) {
						year--;
						mnth = 12;
					}
					var prevurl = "<?php echo geodir_event_manager_ajaxurl().'&event_type=calendar'; ?>&mnth=" + mnth + "&yr=" + year + "&sday=" + sday + "&wday=" + wday;
					jQuery.ajax({
						type: "GET",
						url: prevurl,
						success: function (prev) {
							jQuery('.geodir_event_loading').hide();
							jQuery(".geodir_event_calendar").html(prev);
						}
					});
				});

			};
		}



		jQuery(document).ready(function(){
			if(typeof geodir_event_call_calendar == 'function') {
				geodir_event_call_calendar();
			}
		});

	</script>

	<?php

	echo $after_widget;
}

/*
 * Matches each symbol of PHP date format standard
 * with jQuery equivalent codeword
 */
function geodir_event_date_format_php_to_jqueryui( $php_format ) {
    $symbols = array(
        // Day
        'd' => 'dd',
        'D' => 'D',
        'j' => 'd',
        'l' => 'DD',
        'N' => '',
        'S' => '',
        'w' => '',
        'z' => 'o',
        // Week
        'W' => '',
        // Month
        'F' => 'MM',
        'm' => 'mm',
        'M' => 'M',
        'n' => 'm',
        't' => '',
        // Year
        'L' => '',
        'o' => '',
        'Y' => 'yy',
        'y' => 'y',
        // Time
        'a' => 'tt',
        'A' => 'TT',
        'B' => '',
        'g' => 'h',
        'G' => 'H',
        'h' => 'hh',
        'H' => 'HH',
        'i' => 'mm',
        's' => '',
        'u' => ''
    );
	
	$jqueryui_format = "";
	$escaping = false;
    
	for ( $i = 0; $i < strlen( $php_format ); $i++ ) {
        $char = $php_format[$i];
        
		// PHP date format escaping character
	    if ( $char === '\\' ) {
            $i++;
            
			if ( $escaping ) {
				$jqueryui_format .= $php_format[$i];
			} else {
				$jqueryui_format .= '\'' . $php_format[$i];
			}
			
            $escaping = true;
        } else {
            if ( $escaping ) {
				$jqueryui_format .= "'";
				$escaping = false;
			}
			
            if ( isset( $symbols[$char] ) ) {
                $jqueryui_format .= $symbols[$char];
			} else {
                $jqueryui_format .= $char;
			}
        }
    }
	
	return $jqueryui_format;
}

function geodir_event_is_date( $date ) {
	$date = trim( $date );
	
	if ( $date == '' || $date == '0000-00-00 00:00:00' || $date == '0000-00-00' ) {
		return false;
	}
	
	$year = (int)date_i18n( 'Y', strtotime( $date ) );
	
	if ( $year > 1970 ) {
		return true;
	}
	
	return false;
}
 
function geodir_event_date_occurrences( $type = 'year', $start_date, $end_date = '', $interval = 1, $limit = '', $repeat_end = '', $repeat_days = array(), $repeat_weeks = array() ) {
	$dates = array();
	$start_time = strtotime( $start_date );
	$end_time = strtotime( $repeat_end );

	switch ( $type ) {
		case 'year': {
			if ( $repeat_end != '' && geodir_event_is_date( $repeat_end ) ) {
				for ( $time = $start_time; $time <= $end_time; $time = strtotime( date_i18n( 'Y-m-d', $time ) . '+' . $interval . ' year' ) ) {
					$year = date_i18n( 'Y', $time );
					$month = date_i18n( 'm', $time );
					$day = date_i18n( 'd', $time );
					
					$date_occurrence = $year . '-' . $month . '-' . $day;
					$time_occurrence = strtotime( $date_occurrence );
					
					if ( $time_occurrence <= $end_time ) {
						$dates[] = $date_occurrence;
					}
				}
			} else {
				$dates[] = date_i18n( 'Y-m-d', $start_time );
				
				if ( $limit > 0 ) {
					for ( $i = 1; $i < $limit ; $i++ ) {
						$every = $interval * $i;
						$time = strtotime( $start_date . '+' . $every . ' year' );
						
						$year = date_i18n( 'Y', $time );
						$month = date_i18n( 'm', $time );
						$day = date_i18n( 'd', $time );
						
						$date_occurrence = $year . '-' . $month . '-' . $day;
						
						$dates[] = $date_occurrence;
					}
				}
			}
		}
		break;
		case 'month': {
			if ( $repeat_end != '' && geodir_event_is_date( $repeat_end ) ) {
				for ( $time = $start_time; $time <= $end_time; $time = strtotime( date_i18n( 'Y-m-d', $time ) . '+' . $interval . ' month' ) ) {
					$year = date_i18n( 'Y', $time );
					$month = date_i18n( 'm', $time );
					$day = date_i18n( 'd', $time );
					
					$date_occurrence = $year . '-' . $month . '-' . $day;
					$time_occurrence = strtotime( $date_occurrence );
					
					if ( !empty( $repeat_days ) || !empty( $repeat_weeks ) ) {
						$month_days = cal_days_in_month( CAL_GREGORIAN, $month, $year );												
						for ( $d = 1; $d <= $month_days; $d++ ) {
							$recurr_time = strtotime( $year . '-' . $month . '-' . $d );
							$week_day = date_i18n( 'w', $recurr_time );
							$week_diff = ( $recurr_time - strtotime( $year . '-' . $month . '-01' ) );
							$week_num = $week_diff > 0 ? (int)( $week_diff / ( DAY_IN_SECONDS * 7 ) ) : 0;
							$week_num++;														
							
							if ( $recurr_time >= $start_time && $recurr_time <= $end_time ) {
								if ( empty( $repeat_days ) && !empty( $repeat_weeks ) && in_array( $week_num, $repeat_weeks ) ) {
									$dates[] = date_i18n( 'Y-m-d', $recurr_time );
								} else if ( !empty( $repeat_days ) && empty( $repeat_weeks ) && in_array( $week_day, $repeat_days ) ) {
									$dates[] = date_i18n( 'Y-m-d', $recurr_time );
								} else if ( !empty( $repeat_weeks ) && in_array( $week_num, $repeat_weeks ) && !empty( $repeat_days ) && in_array( $week_day, $repeat_days ) ) {
									$dates[] = date_i18n( 'Y-m-d', $recurr_time );
								}
							}
						}
					} else {
						$dates[] = $date_occurrence;
					}
				}
			} else {
				$dates[] = date_i18n( 'Y-m-d', $start_time );
				
				if ( $limit > 0 ) {
					if ( !empty( $repeat_days ) || !empty( $repeat_weeks ) ) {
						$dates = array();
						$week_dates = array();
						$days_limit = 0;
						
						$i = 0;
						while ( $days_limit <= $limit ) {
							$time = strtotime( $start_date . '+' . ( $interval * $i ) . ' month' );
							$year = date_i18n( 'Y', $time );
							$month = date_i18n( 'm', $time );
							$day = date_i18n( 'd', $time );
							
							$month_days = cal_days_in_month( CAL_GREGORIAN, $month, $year );
							for ( $d = 1; $d <= $month_days; $d++ ) {
								$recurr_time = strtotime( $year . '-' . $month . '-' . $d );
								$week_day = date_i18n( 'w', $recurr_time );
								$week_diff = ( $recurr_time - strtotime( $year . '-' . $month . '-01' ) );
								$week_num = $week_diff > 0 ? (int)( $week_diff / ( DAY_IN_SECONDS * 7 ) ) : 0;
								$week_num++;
								
								if ( $recurr_time >= $start_time && in_array( $week_day, $repeat_days ) ) {
									$week_date = '';
									
									if ( empty( $repeat_days ) && !empty( $repeat_weeks ) && in_array( $week_num, $repeat_weeks ) ) {
										$week_date = date_i18n( 'Y-m-d', $recurr_time );
									} else if ( !empty( $repeat_days ) && empty( $repeat_weeks ) && in_array( $week_day, $repeat_days ) ) {
										$week_date = date_i18n( 'Y-m-d', $recurr_time );
									} else if ( !empty( $repeat_weeks ) && in_array( $week_num, $repeat_weeks ) && !empty( $repeat_days ) && in_array( $week_day, $repeat_days ) ) {
										$week_date = date_i18n( 'Y-m-d', $recurr_time );
									}
									if ( $week_date != '' ) {
										$dates[] = $week_date;
										$days_limit++;
									}
									
									if ( count( $dates ) == $limit ) {
										break 2;
									}
								}
							}
							$i++;
							
						}
						
						$dates = !empty( $dates ) ? $dates : date_i18n( 'Y-m-d', $start_time );
					} else {
						for ( $i = 1; $i < $limit ; $i++ ) {
							$every = $interval * $i;
							$time = strtotime( $start_date . '+' . $every . ' month' );
							
							$year = date_i18n( 'Y', $time );
							$month = date_i18n( 'm', $time );
							$day = date_i18n( 'd', $time );
							
							$date_occurrence = $year . '-' . $month . '-' . $day;
							
							$dates[] = $date_occurrence;
						}
					}
				}
			}
		}
		break;
		case 'week': {
			if ( $repeat_end != '' && geodir_event_is_date( $repeat_end ) ) {
				for ( $time = $start_time; $time <= $end_time; $time = strtotime( date_i18n( 'Y-m-d', $time ) . '+' . $interval . ' week' ) ) {
					$year = date_i18n( 'Y', $time );
					$month = date_i18n( 'm', $time );
					$day = date_i18n( 'd', $time );
					
					$date_occurrence = $year . '-' . $month . '-' . $day;
					$time_occurrence = strtotime( $date_occurrence );
					
					if ( $time_occurrence <= $end_time ) {
						if ( !empty( $repeat_days ) ) {
							for ( $d = 0; $d <= 6; $d++ ) {
								$recurr_time = strtotime( $date_occurrence . '+' . $d . ' day' );
								$week_day = date_i18n( 'w', $recurr_time );
								
								if ( in_array( $week_day, $repeat_days ) ) {
									$dates[] = date_i18n( 'Y-m-d', $recurr_time );
								}
							}
						} else {
							$dates[] = $date_occurrence;
						}
					}
				}
			} else {
				$dates[] = date_i18n( 'Y-m-d', $start_time );
				
				if ( $limit > 0 ) {
					if ( !empty( $repeat_days ) ) {
						$dates = array();
						$week_dates = array();
						$days_limit = 0;
						
						$i = 0;
						while ( $days_limit <= $limit ) {
							$time = strtotime( $start_date . '+' . $i . ' week' );
							$year = date_i18n( 'Y', $time );
							$month = date_i18n( 'm', $time );
							$day = date_i18n( 'd', $time );
							
							$date_occurrence = $year . '-' . $month . '-' . $day;
							
							for ( $d = 0; $d <= 6; $d++ ) {
								$recurr_time = strtotime( $date_occurrence . '+' . $d . ' day' );
								$week_day = date_i18n( 'w', $recurr_time );
								
								if ( in_array( $week_day, $repeat_days ) ) {
									$week_dates[] = date_i18n( 'Y-m-d', $recurr_time );
									$dates[] = date_i18n( 'Y-m-d', $recurr_time );
									$days_limit++;
									
									if ( count( $dates ) == $limit ) {
										break 2;
									}
								}
							}
							$i++;
							
						}
						
						$dates = !empty( $dates ) ? $dates : date_i18n( 'Y-m-d', $start_time );
					} else {
						for ( $i = 1; $i < $limit ; $i++ ) {
							$every = $interval * $i;
							$time = strtotime( $start_date . '+' . $every . ' week' );
							
							$year = date_i18n( 'Y', $time );
							$month = date_i18n( 'm', $time );
							$day = date_i18n( 'd', $time );
							
							$date_occurrence = $year . '-' . $month . '-' . $day;
							
							$dates[] = $date_occurrence;
						}
					}
				}
			}
		}
		break;
		case 'day': {
			if ( $repeat_end != '' && geodir_event_is_date( $repeat_end ) ) {
				for ( $time = $start_time; $time <= $end_time; $time = strtotime( date_i18n( 'Y-m-d', $time ) . '+' . $interval . ' day' ) ) {
					$year = date_i18n( 'Y', $time );
					$month = date_i18n( 'm', $time );
					$day = date_i18n( 'd', $time );
					
					$date_occurrence = $year . '-' . $month . '-' . $day;
					$time_occurrence = strtotime( $date_occurrence );
					
					if ( $time_occurrence <= $end_time ) {
						$dates[] = $date_occurrence;
					}
				}
			} else {
				$dates[] = date_i18n( 'Y-m-d', $start_time );
				
				if ( $limit > 0 ) {
					for ( $i = 1; $i < $limit ; $i++ ) {
						$every = $interval * $i;

						$time = strtotime( $start_date . '+' . $every . ' day' );
						
						$year = date_i18n( 'Y', $time );
						$month = date_i18n( 'm', $time );
						$day = date_i18n( 'd', $time );
						
						$date_occurrence = $year . '-' . $month . '-' . $day;
						
						$dates[] = $date_occurrence;
					}
				}
			}
		}
		break;
	}

	$dates = !empty( $dates ) ? array_unique( $dates ) : $dates;
	
	return $dates;
}

function geodir_event_schedule_exist( $date, $event_id ) {
	global $wpdb;
	
	$date = date_i18n( 'Y-m-d', strtotime( $date ) );
	
	$sql = "SELECT * FROM `" . EVENT_SCHEDULE . "` WHERE event_id=" . (int)$event_id . " AND ( ( event_enddate = '0000-00-00' AND DATE_FORMAT( event_date, '%Y-%m-%d') = '" . $date . "' ) OR ( event_enddate != '0000-00-00' AND DATE_FORMAT( event_date, '%Y-%m-%d') <= '" . $date . "' AND '" . $date . "' <= DATE_FORMAT( event_enddate, '%Y-%m-%d') ) )";
	
	if ( $wpdb->get_var( $sql ) ) {
		return true;
	}
	return false;
}

/**
 * Check package has recurring enabled
 */
function geodir_event_recurring_pkg( $post, $package_info = array() ) {
	$package_info = geodir_post_package_info( $package_info, $post );
	
	$recurring_pkg = true;
	
	if ( is_plugin_active( 'geodir_payment_manager/geodir_payment_manager.php' ) ) {
		if ( !empty( $package_info ) && isset( $package_info->recurring_pkg ) && (int)$package_info->recurring_pkg == 1 ) {
			$recurring_pkg = false;
		};
	}
	
	if ( get_option( 'geodir_event_disable_recurring' ) ) {
		$recurring_pkg = false;
	}
	 
	return apply_filters( 'geodir_event_recurring_pkg', $recurring_pkg, $post, $package_info );
}

function geodir_event_parse_dates( $dates_input, $array = true ) {
	$dates = array();
	
	if ( !empty( $dates_input ) && $dates_input != '' ) {
		if ( !is_array( $dates_input ) ) {
			$dates_input = explode( ',', $dates_input );
		}
		
		if ( !empty( $dates_input ) ) {
			foreach ( $dates_input as $date ) {
				$date = trim( $date );
				if ( $date != '' && geodir_event_is_date( $date ) ) {
					$dates[] = $date;
				}
			}
		}
	}
	
	if ( !$array ) {
		$dates = implode( ',', $dates );
	}
	
	return $dates;
}

/**
 * Event calendar date format
 *
 */
function geodir_event_date_format() {

    // if the separator is a slash (/), then the American m/d/y is assumed; whereas if the separator is a dash (-) or a dot (.), then the European d-m-y format is assumed.
	return apply_filters( 'geodir_add_event_calendar_date_format', 'Y-m-d' );
}

/**
 * Retrive the page title for the listing page.
 *
 * @since 1.1.8
 *
 * @param  string $page_title Page title.
 * @return string Listing page title.
 */
function geodir_event_listing_page_title($page_title = '') {
	$current_posttype = geodir_get_current_posttype();
	
	if ( geodir_is_page( 'listing' ) && $current_posttype == 'gd_event' && isset( $_REQUEST['venue'] ) && $_REQUEST['venue'] != '' ) {
		$venue = explode( '-', $_REQUEST['venue'], 2);
		$venue_info = !empty($venue) && isset($venue[0]) ? get_post((int)$venue[0]) : array();
		
		if ( !empty( $venue_info ) && isset( $venue_info->post_title ) && $venue_info->post_title != '' )
			$page_title = wp_sprintf( __( '%s at %s', 'geodirevents' ), $page_title, $venue_info->post_title );
	}
		
	return $page_title;
}

/**
 * Filter the past events count in terms array results.
 *
 * @since 1.1.9
 *
 * @param array $terms Array of terms.
 * @param array $taxonomies Array of post taxonomies.
 * @param array $args Terms arguements.
 * @return array Array of terms.
 */
function geodir_event_get_terms( $terms, $taxonomies, $args ) {
	if ( isset( $args['gd_event_no_loop'] ) ) {
		return $terms; // Avoid an infinite loop.
	}
	
	$args['gd_event_no_loop'] = true;
	
	$gd_event_post_type = 'gd_event';
	
	$gd_event_taxonomy = $gd_event_post_type . 'category';
	
	if ( !empty( $terms ) && in_array( $gd_event_taxonomy, $taxonomies ) ) {
		$query_args = array (
			'is_geodir_loop' => true,
			'post_type' => $gd_event_post_type,
			'gd_location' => true,
		);
			
		$new_terms = array();
		
		foreach ( $terms as $key => $term ) {
			$new_term = $term;
			
			if ( isset( $term->taxonomy ) && $term->taxonomy == $gd_event_taxonomy ) {				
				$tax_query = array(
					'taxonomy' => $gd_event_taxonomy,
					'field' => 'id',
					'terms' => $term->term_id
				);
				
				$query_args['tax_query'] = array($tax_query);
				
				$new_term->count = geodir_get_widget_listings( $query_args, true );
			}
			
			$new_terms[$key] = $new_term;
		}
		
		$terms = $new_terms;
	}

	return $terms;
}

/**
 * Add the query vars to the term link to retrive today & upcoming events.
 *
 * @since 1.1.9
 *
 * @param string $term_link The term permalink.
 * @param int    $cat->term_id The term id.
 * @param string $post_type Wordpress post type.
 * @return string The category term link.
 */
function geodir_event_category_term_link( $term_link, $term_id, $post_type ) {
	if ( $post_type != 'gd_event' ) {
		return $term_link;
	}
	
	$term_link = add_query_arg( array( 'etype' => 'upcoming' ), $term_link );

	return $term_link;
}

/**
 * Update the terms reviews count for upcoming events.
 *
 * @since 1.2.4
 */
function geodir_event_review_count_force_update() {
	$today_date = date_i18n( 'Y-m-d', current_time( 'timestamp' ) );
	$last_update_date = get_option( 'geodir_review_count_force_update' );
	
	if ( !$last_update_date || strtotime( $last_update_date ) < strtotime( $today_date ) ) {
		// update terms reviews count
		geodir_count_reviews_by_terms(true);
		
		// update location reviews count
		if (defined('POST_LOCATION_TABLE')) {
			geodir_event_location_update_count_reviews();
		}
				
		update_option('geodir_review_count_force_update', $today_date );
	}
}

/**
 * Update the reviews count for upcoming events for current location.
 *
 * @since 1.2.4
 *
 * @global object $wpdb WordPress Database object.
 * @global string $plugin_prefix Geodirectory plugin table prefix.
 *
 * @return bool True if update, otherwise false.
 */
function geodir_event_location_update_count_reviews() {
	global $wpdb, $plugin_prefix;
	
	$listing_table = $plugin_prefix . 'gd_event_detail';
	$today_date = date_i18n( 'Y-m-d', current_time( 'timestamp' ) );
	
	$sql = "SELECT ed.post_id FROM `" . $listing_table . "` AS ed INNER JOIN " . EVENT_SCHEDULE . " AS es ON (es.event_id = ed.post_id) WHERE ed.post_locations !='' AND es.event_enddate = '" . date_i18n( 'Y-m-d', strtotime($today_date . ' -1 day')  ) . "'";
	$rows = $wpdb->get_results($sql);
	if (!empty($rows)) {
		foreach ($rows as $row) {
			$post_id = $row->post_id;
			geodir_term_review_count_update($post_id);
		}
		
		return true;
	}
	
	return false;;
}

/**
 * Filter reviews sql query fro upcomin events.
 *
 * @since 1.2.4
 *
 * @global object $wpdb WordPress Database object.
 * @global string $plugin_prefix Geodirectory plugin table prefix.
 *
 * @param string $sql Database sql query.
 * @param int $term_id The term ID.
 * @param int $taxonomy The taxonomy Id.
 * @param string $post_type The post type.
 * @return string Database sql query.
 */
function geodir_event_count_reviews_by_term_sql($sql, $term_id, $taxonomy, $post_type) {
	if ($term_id > 0 && $post_type == 'gd_event') {
		global $wpdb, $plugin_prefix;
		
		$listing_table = $plugin_prefix . $post_type . '_detail';
		
		$current_date = date_i18n( 'Y-m-d', current_time( 'timestamp' ) );
		
		$sql = "SELECT COALESCE(SUM(ed.rating_count),0) FROM `" . $listing_table . "` AS ed INNER JOIN " . EVENT_SCHEDULE . " AS es ON (es.event_id = ed.post_id) WHERE ed.post_status = 'publish' AND ed.rating_count > 0 AND FIND_IN_SET(" . $term_id . ", ed." . $taxonomy . ")";
		$sql .= " AND (es.event_date >= '" . $current_date . "' OR (es.event_date <= '" . $current_date . "' AND es.event_enddate >= '" . $current_date . "'))";
	}
	
	return $sql;
}

/**
 * Filter reviews sql query fro upcoming events for current location.
 *
 * @since 1.2.4
 *
 * @global object $wpdb WordPress Database object.
 * @global string $plugin_prefix Geodirectory plugin table prefix.
 *
 * @param string $sql Database sql query.
 * @param int $term_id The term ID.
 * @param int $taxonomy The taxonomy Id.
 * @param string $post_type The post type.
 * @param string $location_type Location type .
 * @param array $loc Current location terms.
 * @param string $count_type The term count type.
 * @return string Database sql query.
 */
function geodir_event_count_reviews_by_location_term_sql($sql, $term_id, $taxonomy, $post_type, $location_type, $loc, $count_type) {
	if ($term_id > 0 && $post_type == 'gd_event') {
		global $wpdb, $plugin_prefix;
		
		if ($count_type == 'review_count') {			
			$listing_table = $plugin_prefix . $post_type . '_detail';
			
			$current_date = date_i18n( 'Y-m-d', current_time( 'timestamp' ) );
			
			if (!$loc) {
				$loc = geodir_get_current_location_terms();
			}
			
			$country = isset($loc['gd_country']) && $loc['gd_country'] != '' ? $loc['gd_country'] : '';
			$region = isset($loc['gd_region']) && $loc['gd_region'] != '' ? $loc['gd_region'] : '';
			$city = isset($loc['gd_city']) && $loc['gd_city'] != '' ? $loc['gd_city'] : '';
			
			$where = '';
			if ( $country!= '') {
				$where .= " AND ed.post_locations LIKE '%,[".$country."]' ";
			}
			
			if ( $region != '' && $location_type!='gd_country' ) {
				$where .= " AND ed.post_locations LIKE '%,[".$region."],%' ";
			}
			
			if ( $city != '' && $location_type!='gd_country' && $location_type!='gd_region' ) {
				$where .= " AND ed.post_locations LIKE '[".$city."],%' ";
			}
			
			$sql = "SELECT COALESCE(SUM(ed.rating_count),0) FROM `" . $listing_table . "` AS ed INNER JOIN " . EVENT_SCHEDULE . " AS es ON (es.event_id = ed.post_id) WHERE ed.post_status = 'publish' " . $where . " AND ed.rating_count > 0 AND FIND_IN_SET(" . $term_id . ", ed." . $taxonomy . ")";
			
			$sql .= " AND (es.event_date >= '" . $current_date . "' OR (es.event_date <= '" . $current_date . "' AND es.event_enddate >= '" . $current_date . "'))";
		}
	}
	
	return $sql;
}

/**
 * Filter the page link to best of widget view all lisitngs.
 *
 * @since 1.2.4
 *
 * @param string $view_all_link View all listings page link.
 * @param string $post_type The Post type.
 * @param object $term The category term object.
 * @return string Link url.
 */
function geodir_event_bestof_widget_view_all_link($view_all_link, $post_type, $term) {
	if ($post_type == 'gd_event') {
		$view_all_link = add_query_arg(array('etype' => 'upcoming'), $view_all_link) ;
	}
	return $view_all_link;
}